<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');







class Dashboard extends CI_Controller {



    public function __construct()
	{
        parent::__construct();

        $this->load->model(array('user_model','domain_model', 'subscriber_model', 'template_model','email_model'));

		 $this->load->helper(array('form', 'url', 'date'));

        $this->load->library('session', 'encrypt');

		$this->load->library('template');

		date_default_timezone_set('Asia/Calcutta');

		if(!($this->session->userdata('userid')) or !($this->session->userdata('role')))
		{

			redirect(site_url("user/logout"));

		}

	}



	public function index()
	{
		$result['msg']='';	

		$result['total_domains'] = $this->domain_model->get_total_domains();

		$result['total_templates'] = $this->template_model->get_total_templates();

		$result['total_subscribers'] = $this->subscriber_model->get_total_subscribers();
		//get sent emails on this month,week or today
		$month_start = date('Y-m-d', strtotime('-30 days'));
    	$week_start = date('Y-m-d', strtotime('-6 days'));
    	$today = date('Y-m-d');
    	$today_mails = $this->email_model->get_emails();
    	$today_mail_count = 0;
    	foreach ($today_mails as $key) {
    		$today_mail_count+=$key['sent_mail'];
    	}
    	$result['today_mails']=$today_mail_count;
    	//$result['week_mails']=$this->email_model->get_emails($week_start,$today);
    	$month_mail_count = 0;
    	$month_mails = $this->email_model->get_emails($month_start,$today);
    	foreach ($month_mails as $key) {
    		$month_mail_count+=$key['sent_mail'];
    	}
    	$result['month_mails']=$month_mail_count;
		//echo"<pre>";
		//print_r($result);die;
		$this->template->title('Dashboard');

		$this->template->set_layout('default')->build("dashboard",$result);

	}
	//remove emails which send 1 year ago from current date
	public function remove_sent_email()
	{
		$year_date = date('Y-m-d', strtotime('-365 days'));
		if($this->email_model->delete_emails($year_date))
		{
			echo"One year ago emails removed.";
		}
		else
		{
			echo "failed to remove emails";
		}
		//echo $year_date;
	}
	public function test_date()
	{
		$this->load->view('test-date');
	}

	public function google_contacts()
	{
		$Google_api_client_id = GOOGLE_API_CLIENT_ID;
		$Google_client_secret = GOOGLE_CLIENT_SECRET;
		$Google_redirect_url = GOOGLE_REDIRECT_URL; // redirect url mentioned in aapi console
		$Google_contact_max_result = GOOGLE_CONTACT_MAX_RESULT; // integer value
		$authcode= $_GET["code"];
		$clientid=$Google_api_client_id;
		$clientsecret=$Google_client_secret;
		$redirecturi=$Google_redirect_url ;
		$fields=array(
		'code'=>  urlencode($authcode),
		'client_id'=>  urlencode($clientid),
		'client_secret'=>  urlencode($clientsecret),
		'redirect_uri'=>  urlencode($redirecturi),
		'grant_type'=>  urlencode('authorization_code')
		);
		$fields_string="";
		foreach($fields as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
		$fields_string=rtrim($fields_string,'&');
		//open connection
		$ch = curl_init();
		//set the url, number of POST vars, POST data
		curl_setopt($ch,CURLOPT_URL,'https://accounts.google.com/o/oauth2/token');
		curl_setopt($ch,CURLOPT_POST,5);
		curl_setopt($ch,CURLOPT_POSTFIELDS,$fields_string);
		// Set so curl_exec returns the result instead of outputting it.
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		//to trust any ssl certificates
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		//execute post
		$result = curl_exec($ch);
		//close connection
		curl_close($ch);
		//extracting access_token from response string
		$response   =  json_decode($result);
		
		$accesstoken= $response->access_token;
		if( $accesstoken!="")
		$_SESSION['token']= $accesstoken;
		//passing accesstoken to obtain contact details
		$xmlresponse=  file_get_contents('https://www.google.com/m8/feeds/contacts/default/full?&max-results='.$Google_contact_max_result .'&alt=json&v=3.0&oauth_token='.$_SESSION['token']);
		
		$contacts = json_decode($xmlresponse,true);
		$return = array();
		if (!empty($contacts['feed']['entry'])) {
			foreach($contacts['feed']['entry'] as $contact) {
	           //retrieve Name and email address  
				if (!array_key_exists('gd$email', $contact)){
				    continue;
				}
				else
				{
					$return[] = array (
						'name'=> $contact['title']['$t'],
						'email' => $contact['gd$email'][0]['address'],
					);	
				}
				
			}				
		}
		$google_contacts = $return;
		echo "<pre>";
		print_r($google_contacts);

		
	}

	public function testing()
	{
		"working fine";
	}




} // End of the controller