<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Domain extends CI_Controller {

    public function __construct()
	{
        parent::__construct();
        $this->load->model(array('domain_model'));
        $this->load->helper(array('form', 'url', 'date'));
        $this->load->library('form_validation');
        $this->load->library('session', 'encrypt');
		$this->load->library('template');
		date_default_timezone_set('Asia/Calcutta');		
		if(!($this->session->userdata('userid')) or !($this->session->userdata('role'))){
		  redirect(site_url("user/logout"));
		}
	}

	public function index()
	{
		$result['msg']='';		
		//$this->domain_model->update_domain_email_status();
		$result['domains'] = $this->domain_model->get_domain_list();		

		$this->template->title('Domain List');

		$this->template->set_layout('default')->build("domain_list",$result);
	}

	public function domain_add()
	{		
		$result['msg']='';		
		if($_POST)

		{
			$this->form_validation->set_rules('domain', 'domain name', "trim|required||min_length[10]|max_length[50]|callback_valid_url_format");

			$this->form_validation->set_rules('email', 'domain email', "trim|required|min_length[5]|max_length[50]|valid_email");

			$this->form_validation->set_rules('description', 'description', 'trim|max_length[250]');

			if ($this->form_validation->run()) 
			{	 			         			
				$data=array
				(		

				'url'=>$this->input->post("domain"),

				'domain_email'=>$this->input->post("email"),

				'description'=>$this->input->post("description"),

				'owner'=>$this->session->userdata('userid'),

				'is_active'=>"1",

				'created'=>date("Y-m-d H:i:s")							
				);

				if($this->domain_model->insert_domains($data))
				{						
					$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><br/><b>New domain inserted successfully</b></span></div>');

					redirect(site_url("domain/domain_add"));
				}
				else
				{
					$result['msg']="Data not saved. Try again !";			
				}

			}

		}		

		$this->template->title('Add Domain');

		$this->template->set_layout('default')->build("domain_add",$result);

	}	



	function valid_url_format($str){

        $pattern = "|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i";



        if (!preg_match($pattern, $str)){



            $this->form_validation->set_message('valid_url_format', 'The URL you entered is not correctly formatted.');



            return FALSE;

        } 

        return TRUE;

    } 

    public function email_report(){
    	//echo "working";
    	$this->db->select("email_reports.id,count(email_reports.id) as opened_email,d.domain_email,d.description as domain_name,publish_emails.sent_mail_id,sent_emails.subject");
    	$this->db->from('email_reports');
    	$this->db->join("domains as d", "d.id = email_reports.domain_id");
    	$this->db->join("publish_emails","publish_emails.id=email_reports.publish_email_id",'left');
    	$this->db->join("sent_emails","sent_emails.id=publish_emails.sent_mail_id",'left');
    	$this->db->group_by("sent_emails.subject");
		$data['results'] = $this->db->get()->result_array();
		//echo "<pre>";
		//print_r($data['results']);die;
		$data['msg'] = "";
		
		$this->template->title('Email Report');
		$this->template->set_layout('default')->build("email-report",$data);
    }    

	

	

	// Not in use

	/*public function verify_email($domainid=0)

	{

		$this->load->library('simpleemailservice','', 'sms');

		$this->load->library('Simpleemailservicemessage','', 'smsm');

		$email_list = $this->sms->listVerifiedEmailAddresses();

		

		$this->db->select("domains.id, domains.domain_email, domains.email_status");

		$this->db->from("domains");

		$this->db->where(array("domains.id"=>$domainid));

		

		$result = $this->db->get()->row_array();		

	

		if(count($result) > 0)

		{

			$count =0;

			foreach($email_list["Addresses"] as $email)

			{

				if(strtoupper($email)==strtoupper($result["domain_email"]))

				{	

					$count = 1;

					$this->db->where(array("domains.id"=>$result["id"]));

        			$this->db->update("domains", array("domains.email_status"=>1));

					break;

				}

			}

			

			if($count == 1)

			{

				$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>Your email successfully verified.</b></span></div>');

			}

			else

			{

				$this->sms->verifyEmailAddress($result["domain_email"]);

				$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>We have sent sent a verification request. Check your mail box.</b></span></div>');

			}			

		}		

		

		redirect(site_url('domain'));

	}*/




	/*public function test()
	{
		$ip ="";
		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
			$ip = $_SERVER['HTTP_CLIENT_IP'];
		} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		}
		echo "IP : ". $ip."<br>";
		$arr = $this->db->select("id, email")->get("subscribers")->result_array();
		$i=0;
		foreach($arr as $row)
		{
			if(!$this->form_validation->valid_emails($row["email"]))
			{
				echo $row["id"]." ".$row["email"]."<br>";
				$i++;
			}
			
		}
		echo $i;
	}*/


	







} // End of the controller