<?php if( ! defined('BASEPATH')) exit('No direct script access allowed');



class Sent_mail extends CI_Controller {



    public function __construct()
	{

        parent::__construct();

        $this->load->model(array('email_model', 'domain_model', 'template_model','subscriber_model'));

        $this->load->helper(array('form', 'url', 'date'));

        $this->load->library('form_validation');

        $this->load->library('session', 'encrypt');

		$this->load->library('template');

		date_default_timezone_set('Asia/Calcutta');	

		if(!($this->session->userdata('userid')) or !($this->session->userdata('role'))){

		  redirect(site_url("user/logout"));

		}
		$this->load->library('pagination');

		$config['full_tag_open'] 	= '<ul class="pagination">';

		$config['full_tag_close'] 	= '</ul>';

		$config['first_link'] 		= 'First';

		$config['first_tag_open'] 	= '<li>';

		$config['first_tag_close'] 	= '</li>';

		$config['last_link'] 		= 'Last';

		$config['last_tag_open'] 	= '<li>';

		$config['last_tag_close'] 	= '</li>';

		$config['next_link'] 		= 'Next &gt;';

		$config['next_tag_open'] 	= '<li>';

		$config['next_tag_close'] 	= '</li>';

		$config['prev_link'] 		= '&lt; Prev';

		$config['prev_tag_open'] 	= '<li>';

		$config['prev_tag_close'] 	= '</li>';

		$config['cur_tag_open'] 	= '<li class="active"><a href="#">';

		$config['cur_tag_close'] 	= '</a></li>';

		$config['num_tag_open'] 	= '<li>';

		$config['num_tag_close'] 	= '</li>';

		$this->pagination->initialize($config);	

	}



	public function index()
	{

		$result['msg']='';

		$result['domains'] = $this->domain_model->get_domain_list();

		$this->template->title('Mail Settings');

		$this->template->set_layout('default')->build("mail_settings",$result);

	}
	public function mail_settings()
	{	

		$result['msg']='';



		if($_POST)

		{

			$this->form_validation->set_rules('domain', 'domain name', "trim|required");

			$this->form_validation->set_rules('template', 'templates', "trim|required");

			$this->form_validation->set_rules('mail_date', 'mail date', "trim|required|min_length[10]|max_length[10]");

			$this->form_validation->set_rules('subject', 'mail subject', 'trim|required|max_length[200]');



			if ($this->form_validation->run()) 

			{	 	

				$mail_date = $this->input->post("mail_date");

				if($mail_date != '') {

					$a = explode("/", $mail_date);

					$mail_date = $a[2].'-'.$a[1].'-'.$a[0];

				}	  

				$arr=array

				(	

				'subject'=>$this->input->post("subject"),

				'template_id'=>$this->input->post("template"),

				'owner'=>$this->session->userdata('userid'),

				'sent_date'=>$mail_date,

				'created'=>date("Y-m-d H:i:s")	

				);



				$this->db->select("subscribers.id");

				$this->db->from("subscribers");

				$this->db->where(array("subscribers.domain_id" => $this->input->post("domain"),"subscribers.is_active" => 1));

				$subscribers = $this->db->get()->result_array();



				if(count($subscribers)<1)

				{

					$this->session->set_flashdata('message', '<div align="left" style="color:red;" id="notify"><span><br/><b>No Active Subscriber please Add Active Subscribers.</b></span></div>');

					redirect(site_url("sent_mail"));

				} 

				else 

				{	

					if($this->email_model->insert_mail_settings($arr))

					{		

						$sent_mail_id = $this->db->insert_id();

						$this->db->select("subscribers.id");

						$this->db->from("subscribers");

						$this->db->where(array("subscribers.domain_id" => $this->input->post("domain"), "subscribers.is_active" => 1));

						$this->db->order_by("subscribers.id", "asc");

						$data["subscribers"] = $this->db->get()->result_array();

						$sql = "INSERT INTO publish_emails(sent_mail_id, subscriber_id, sent_status)VALUES ";

						$sqlstr="";

						foreach($data["subscribers"] as $row)

						{

							$str="";

							$str ="('". $sent_mail_id."','".$row["id"]."',0),";

							$sqlstr .=$str;

							//$subs_arr=array('sent_mail_id'=>$sent_mail_id, 'subscriber_id'=>$row["id"], 'sent_status'=>"0");

							//$this->db->insert("publish_emails",$subs_arr);

						}

						if($sqlstr)

						{

							$this->db->query($sql . rtrim($sqlstr, ","));

							//$inserted_row= $this->db->affected_rows();

						}	



						$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><br/><b>Mail setting inserted successfully.</b></span></div>');

						redirect(site_url("sent_mail"));

					}

					else

					{

					$this->session->set_flashdata('message', '<div align="left" style="color:red;" id="notify"><span><br/><b>Data not saved. Try again !</b></span></div>');

					redirect(site_url("sent_mail"));

				}

				}

			}

		}



		$result['domains'] = $this->domain_model->get_domain_list();	

		$this->template->title('Mail Settings');

		$this->template->set_layout('default')->build("mail_settings",$result);

	}	
	// Call By Ajax

	public function get_templates()
	{		

		$domainid=$this->input->post('domainid');

		if($domainid !="")
		{

			$result['templates']=$this->template_model->get_templates_for_mails($domainid);	

			echo "<option value=''>Select</option>";

			foreach($result['templates'] as $row)

			{			

				echo "<option value='".$row['id']."'>".$row['title']."</option>";

			}

		}

		else

		{

			echo "<option value=''>Select</option>";	

		}

	}



	public function publish_mail_list()

	{		

		$result['msg']='';

		$result['publish_mails'] = $this->email_model->get_publish_mail_list();
		//echo"<pre>";
		//print_r($result);die;
		$this->template->title('Publish Mail List');

		$this->template->set_layout('default')->build("publish_mail_list",$result);

	}



	public function publish_mails_completed($sent_mail_id=0, $remaining_mail=0)

	{		

		$status = 1;

		if($remaining_mail>0)

		{

			$status = 2;

		}

		$this->db->where("sent_emails.id", $sent_mail_id);

        $this->db->update("sent_emails", array("sent_emails.status"=>$status));

		$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>Template mark completed successfully.</b></span></div>');

		redirect(site_url('sent_mail/publish_mail_list'));

	}	



	/*public function publish_mails($sent_mail_id=0)

	{

		$mailfrom = $this->domain_model->check_domain_email_is_verified($sent_mail_id);

		if($mailfrom=="")

		{

			$this->session->set_flashdata('message', '<div align="left" style="color:red;" id="notify"><span><b>Your emailid in not verified. Please contact your administrator.</b></span></div>');

			redirect(site_url('sent_mail/publish_mail_list'));

		}	

		$result['msg']='';

		if($sent_mail_id > 0)

		{

			$this->load->library('swift_required');

		    $this->load->library('Classes/Swift/swift_smtptransport');

			$this->db->select("publish_emails.id, subscribers.name,subscribers.id as send_id, subscribers.email, templates.template, sent_emails.subject");

			$this->db->limit(600, 0);

			$this->db->from("publish_emails");

			$this->db->join("sent_emails", "sent_emails.id = publish_emails.sent_mail_id");

			$this->db->join("templates", "templates.id = sent_emails.template_id");

			$this->db->join("subscribers", "subscribers.id = publish_emails.subscriber_id");

			$this->db->where(array("publish_emails.sent_status"=>"0", "publish_emails.sent_mail_id" => $sent_mail_id));

			$this->db->order_by("publish_emails.id","asc");

			$subscribers = $this->db->get()->result_array();

			//$mailfrom = $this->session->userdata('useremail');

			$body = $subscribers[0]["template"];

			$sub = $subscribers[0]["subject"];	



			if($sub=="" or $mailfrom=="" or $body=="")

			{	

				redirect(site_url("user/logout"));

			}

			

			

			$transport = $this->swift_smtptransport->newinstance('smtp.mandrillapp.com', 587);

			$transport->setUsername('info@innctech.com');

			$transport->setPassword('RLTznhmBBPjJhu298Z4oGg');

			$swift = Swift_Mailer::newInstance($transport);



			$uid=0;

			$startfrom =0;

			$mailcount=0;

			$error_count =0;



			foreach($subscribers as $row)

			{	

				$id = base64_encode($row['send_id']);

				$unsubscribe = "<p style='  font-size: 12px; left: 427px; margin: 0 auto; position: absolute;text-align: center;top: 1542px;'>Click hear to <a href='http://innctech.in/innctech_mailer2/user/unsubscribe/".$id."'/>Unsubscribe</a></p>";



				$templete_body = $body.$unsubscribe ;

				try 

				{	

					$from = array($mailfrom =>'');

					$to = array(

					 $row["email"]  => $row["name"]

					);

					$text = "";

					

					$message = new Swift_Message($sub);

					$message->setFrom($from);

					$message->setBody($templete_body, 'text/html');

					$message->setTo($to);

					$message->addPart($text, 'text/plain');

					$ses_response = "";

					if ($recipients = $swift->send($message, $failures))

					{

						// echo 'Message successfully sent!';

						 $ses_response = "request : Sent";

					} 

					else

					{

						$error_count++;

						$ses_response = "error : error";

						 //echo "There was an error:\n";

						// print_r($failures);

					}	

					if($mailcount==0)

					{

						$startfrom =$row["id"];



					}

					$mailcount++;

					$uid=$row["id"];

					$this->email_model->update_publish_mail($uid, array("publish_emails.sent_status" => "1", "publish_emails.last_sent" => $startfrom, "createdon" => date("Y-m-d H:i:s"), "ses_response" => $ses_response));



					if($error_count == 5)

					{

						break;

					}

					//if($mailcount%5 ==0)

					//{

					//	sleep(1);

					//}

				 } 

				 catch (Exception $e)

				 {

				 }

			}	



			$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>Mail sent to '.$mailcount.' users.</b></span></div>');

		}

		redirect(site_url('sent_mail/publish_mail_list'));

	}*/

	

	

	public function publish_mails($sent_mail_id=0)

	{

		$mailfrom = $this->domain_model->check_domain_email_is_verified($sent_mail_id);

		if($mailfrom=="")

		{

			$this->session->set_flashdata('message', '<div align="left" style="color:red;" id="notify"><span><b>Your emailid in not verified. Please contact your administrator.</b></span></div>');

			redirect(site_url('sent_mail/publish_mail_list'));

		}	

		$result['msg']='';

		if($sent_mail_id > 0)
		{

			$this->db->select("publish_emails.id, subscribers.name,subscribers.id as subscribers_id, subscribers.email, templates.template, sent_emails.subject");

			$this->db->limit(CV_SEND_MAIL_LIMIT, 0);

			$this->db->from("publish_emails");

			$this->db->join("sent_emails", "sent_emails.id = publish_emails.sent_mail_id");

			$this->db->join("templates", "templates.id = sent_emails.template_id");

			$this->db->join("subscribers", "subscribers.id = publish_emails.subscriber_id");

			$this->db->where(array("publish_emails.sent_status"=>"0", "sent_emails.status"=>0, "publish_emails.sent_mail_id" => $sent_mail_id));

			$this->db->order_by("publish_emails.id","asc");

			$subscribers = $this->db->get()->result_array();

			

			$body = $subscribers[0]["template"];

			$subject = $subscribers[0]["subject"];	

			if($subject=="" or $mailfrom=="" or $body=="")

			{	
				redirect(site_url("user/logout"));

			}
	

			foreach($subscribers as $row)
			{	

				$id = base64_encode($row['subscribers_id']);

				/*$unsubscribe = "<p style='  font-size: 12px; left: 427px; margin: 0 auto; position: absolute;text-align: center;top: 1542px;'>Click hear to <a href='".site_url()."user/unsubscribe/".$id."'/>Unsubscribe</a></p>";*/

				$html = explode("Unsubscribe_url",$body);
                
                $unsubscribe = "Click hear to <a  target='_blank' href='".site_url()."user/unsubscribe/".$id."'>Unsubscribe</a>";
                $new_html = "";
                if(count($html)>1){
                    $new_html = $html[0].$unsubscribe.$html[1]; 
                }else{
                    $new_html = $html[0].$unsubscribe;
                }
                
                
                $mail_body = $new_html;

				//$mail_body = $body.$unsubscribe ;

				

				$to_name="";

				if($row["name"])

				{

					$to_name = trim($row["name"]);

				}

								

					$arr = array(

							"tbl_pub_ema_id"=>$row["id"],

							"from_emailid"=>$mailfrom,

							"to_name"=>$to_name,

							"to_emailid"=> $row["email"],

							"subject"=>$subject,

							"body"=>$mail_body

							);

					$this->db->insert("publish_mail_by_cron",$arr);			

				 $this->db->where("publish_emails.id", $row["id"]);

       			 $this->db->update("publish_emails", array("publish_emails.sent_status"=>2));

			}	

			

			



			$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>We have sent this email to your users, it will take some time.</b></span></div>');

		}

		redirect(site_url('sent_mail/publish_mail_list'));

	}





	public function update_subject()

	{

		if($_POST)

		{

			if(($this->input->post("sent_mail_id")>0) and ($this->input->post("txt_subject") != ""))

			{

				$this->db->where("sent_emails.id", $this->input->post("sent_mail_id"));

				$this->db->update("sent_emails", array("sent_emails.subject"=>$this->input->post("txt_subject")));

				$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>Subject successfully updated.</b></span></div>');

			}

		}

		redirect(site_url('sent_mail/publish_mail_list'));

	}

	public function sent_mail_summary()
	{
		$result['msg']='';	
		$result['mails'] = '';
		//set default one weak date
		$date_from = "";
    	$date_to = "";
    	$domain = "";
		$domain_list = $this->domain_model->get_domain_list();
		
		if($this->input->post())
		{
			//print_r($this->input->post());die;
			/*$sess_data = array(
				'se_domain'=>$this->input->post('domain'),
				'se_date_from'=>$this->input->post('date_from'),
				'se_date_to'=>$this->input->post('date_to')
				);
			$this->session->set_userdata($sess_data);*/
			$date_from = $this->input->post('date_from');
			$date_to = $this->input->post('date_to');
			$domain = $this->input->post('domain');
		}
		/*if($this->session->has_userdata('domain')&&$this->session->has_userdata('date_from')&&$this->session->has_userdata('date_to'))
		{
			$date_from = $this->session->userdata('date_from');
    		$date_to = $this->session->userdata('date_to');
    		$domain = $this->session->userdata('domain');
		}*/
		else
		{
			/*$this->session->unset_userdata('date_from');
			$this->session->unset_userdata('date_to');
			$this->session->unset_userdata('domain');*/
			//set default values
			$date_from = date('Y-m-d', strtotime('-6 days'));
    		$date_to = date('Y-m-d');
    		$domain = $domain_list[0]['id'];
		}
		$mail_data = $this->email_model->get_email_report($domain,$date_from,$date_to);
		$mail_array = array();
		$dates = $this->getDatesFromRange($date_from,$date_to);
		for($i = 0;$i<count($dates);$i++)
		{
			$sent=$in_process=$remaining=0;
			foreach ($mail_data as $key) 
			{
				$e_date = date('Y-m-d',strtotime($key['pubdate']));
				if($dates[$i]==$e_date)
				{
					/*if($key['sent_status']==0)
					$remaining++;
					elseif($key['sent_status']==1)
					$sent++;
					elseif($key['sent_status']==2)
					$in_process++;*/
					$remaining = $key['Pending'];	
					$sent = $key['Sent'];	
					$in_process = $key['Inprocess'];
					break;	
				}	
			}
			$array['date'] = $dates[$i];
			$array['sent_mail'] = $sent;
			$array['in_process_mail'] = $in_process;
			$array['remaining_mail'] = $remaining;
			array_push($mail_array, $array);
		}
		$result['mails'] = $mail_array;
		$result['domains'] = $domain_list;
		$result['domain'] = $domain;
		$result['date_from'] = $date_from;
		$result['date_to'] = $date_to;
		//echo $this->db->last_query();
		//echo "<pre>";
		//print_r($result['mails']);die;
		$this->template->title('Mail Report');
		$this->template->set_layout('default')->build("sent-mail-list",$result);

	}

	private function getDatesFromRange($start, $end, $format = 'Y-m-d') 
	{ 
      
	    $array = array(); 
	      
	    $interval = new DateInterval('P1D'); 
	  
	    $realEnd = new DateTime($end); 
	    $realEnd->add($interval); 
	  
	    $period = new DatePeriod(new DateTime($start), $interval, $realEnd); 
	 
	    foreach($period as $date) {                  
	        $array[] = $date->format($format);  
	    } 
	    return $array; 
	} 

	







} // End of the controller