<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');



	class Template_model extends CI_Model{

	function __construct()

	{

		parent::__construct();

		$this->load->database();

	}



	public function get_total_templates()

	{		

		$this->db->select("count(templates.id) as total_templates");

		$this->db->from("templates");

		$this->db->where(array("templates.is_active"=>"1", "domains.owner" => $this->session->userdata('userid')));

		$this->db->join("domains", "domains.id = templates.domain_id");

		return $this->db->get()->row()->total_templates;

	}



	public function get_template_list($pp=25, $range=0)

	{

		$this->db->select("templates.id, templates.title, templates.template, templates.is_active, domains.url");

		$this->db->from("templates");

		$this->db->join("domains", "domains.id = templates.domain_id");

		$this->db->where(array("domains.owner" => $this->session->userdata('userid')));

		$this->db->order_by("domains.url", "asc");

		$this->db->order_by("templates.id", "desc");

		$this->db->limit($pp, $range);

		return $this->db->get()->result_array();

	}

	

	public function get_required_template($templateid)

	{

		$this->db->select("templates.id, templates.domain_id, templates.title, templates.template, templates.is_active");

		$this->db->from("templates");

		$this->db->join("domains", "domains.id = templates.domain_id");

		$this->db->where(array("domains.owner" => $this->session->userdata('userid'), "templates.id" => $templateid));

		return $this->db->get()->row_array();

	}

	

	public function insert_templates($data)

	{

		if($this->db->insert("templates",$data))

		{

			return true;

		}

		else

		{

			return false;

		}

	}	

	



	public function update_templates($templateid, $data)

	{

		$this->db->where("templates.id", $templateid);

        $this->db->update("templates", $data);

		return ($this->db->affected_rows() > 0) ? TRUE : FALSE; 

	}

	

	public function get_templates_for_mails($domainid)

	{

		$this->db->select("templates.id, templates.title, templates.template, templates.is_active, domains.url");

		$this->db->from("templates");

		$this->db->join("domains", "domains.id = templates.domain_id");

		$this->db->where(array("templates.is_active"=>1,"domains.owner" => $this->session->userdata('userid'), "templates.domain_id"=>$domainid));

		$this->db->order_by("templates.title", "asc");

		return $this->db->get()->result_array();

	}



		



		



}// End of the dealer model