<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');



class Mail_template extends CI_Controller {



    public function __construct()

	{

        parent::__construct();

        $this->load->model(array('template_model', 'domain_model'));

        $this->load->helper(array('form', 'url', 'date'));

        $this->load->library('form_validation');

        $this->load->library('session', 'encrypt');

		$this->load->library('template');



		date_default_timezone_set('Asia/Calcutta');		

		

		if(!($this->session->userdata('userid')) or !($this->session->userdata('role'))){

		  redirect(site_url("user/logout"));

		}

		

		$this->load->library('pagination');	

		$config['full_tag_open'] 	= '<ul class="pagination">';

		$config['full_tag_close'] 	= '</ul>';

		$config['first_link'] 		= 'First';

		$config['first_tag_open'] 	= '<li>';

		$config['first_tag_close'] 	= '</li>';

		$config['last_link'] 		= 'Last';

		$config['last_tag_open'] 	= '<li>';

		$config['last_tag_close'] 	= '</li>';

		$config['next_link'] 		= 'Next &gt;';

		$config['next_tag_open'] 	= '<li>';

		$config['next_tag_close'] 	= '</li>';

		$config['prev_link'] 		= '&lt; Prev';

		$config['prev_tag_open'] 	= '<li>';

		$config['prev_tag_close'] 	= '</li>';

		$config['cur_tag_open'] 	= '<li class="active"><a href="#">';

		$config['cur_tag_close'] 	= '</a></li>';

		$config['num_tag_open'] 	= '<li>';

		$config['num_tag_close'] 	= '</li>';

		$this->pagination->initialize($config);

	}



	public function index()

	{

		$result['msg']='';	

		

		$config['base_url'] = site_url('template/index');

		$config['total_rows'] = $this->db->count_all_results('templates');

		$config['per_page'] = 15;		

		$this->pagination->initialize($config);		

		$page = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;

		$result["count"] 			= 	$this->uri->segment(3)+1;

		$result["links"] 			= 	$this->pagination->create_links();		

					

		$result['templates'] = $this->template_model->get_template_list($config["per_page"], $page);		

		$this->template->title('Templates List');

		$this->template->set_layout('default')->build("template_list",$result);

	}

	

	public function template_add()

	{		

		$result['msg']='';		

		

		if($_POST)

		{

			$this->form_validation->set_rules('domain', 'domain name', "trim|required");			

			$this->form_validation->set_rules('status', 'subscriber status', "trim|required");

			$this->form_validation->set_rules('title', 'title', "trim|required|max_length[200]");

			$this->form_validation->set_rules('mail_template', 'template', 'trim|required');

			

			if ($this->form_validation->run()) 

			{	 			         			

				$data=array

				(		

				'title'=>$this->input->post("title"),

				'template'=>$this->input->post("mail_template"),

				'domain_id'=>$this->input->post("domain"),

				'is_active'=>$this->input->post("status"),

				'created'=>date("Y-m-d H:i:s")							

				);

				

				if($this->template_model->insert_templates($data))

				{						

					$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><br/><b>New template inserted successfully</b></span></div>');

					redirect(site_url("mail_template/template_add"));

				}

				else

				{

					$result['msg']="Data not saved. Try again !";			

				}

			}

		}

		

		$result['domains'] = $this->domain_model->get_domain_list();		

		$this->template->title('Add Template');

		$this->template->set_layout('default')->build("template_add",$result);

	}

	

	

	public function template_edit($templateid=0)

	{		

		$result['msg']='';		

		

		if($_POST)

		{

			$this->form_validation->set_rules('domain', 'domain name', "trim|required");			

			$this->form_validation->set_rules('status', 'subscriber status', "trim|required");

			$this->form_validation->set_rules('title', 'title', "trim|required|max_length[200]");

			$this->form_validation->set_rules('mail_template', 'template', 'trim|required');

			

			if ($this->form_validation->run()) 

			{	 			         			

				$data=array

				(		

				'title'=>$this->input->post("title"),

				'template'=>$this->input->post("mail_template"),

				'domain_id'=>$this->input->post("domain"),

				'is_active'=>$this->input->post("status")				

				);

				

				if($this->template_model->update_templates($templateid, $data))

				{						

					$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><br/><b>Template updated successfully</b></span></div>');

					redirect(site_url("mail_template"));

				}

				else

				{

					$result['msg']="Data not updated. Try again !";			

				}

			}

		}

		

		$result['mail_template'] = $this->template_model->get_required_template($templateid);

		$result['domains'] = $this->domain_model->get_domain_list();

		$this->template->title('Edit Template');

		$this->template->set_layout('default')->build("template_add",$result);

	}

	

	

	public function template_view($templateid=0)

	{		

		$result['msg']='';			

		

		$result['mail_template'] = $this->template_model->get_required_template($templateid);		

		

		$this->load->view("template_view",$result);

	}

	

		



} // End of the controller