<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class User extends CI_Controller {

    public function __construct()
	{
        parent::__construct();
        $this->load->model('user_model', '', TRUE);
		 $this->load->model('domain_model', '', TRUE);
        $this->load->helper(array('form', 'url', 'date'));
        $this->load->library('form_validation');
        $this->load->library(['session','encrypt']);
		$this->load->library('template');		

		$this->load->library('email');
		$config['protocol'] = 'sendmail';
        $config['mailpath'] = '/usr/sbin/sendmail';
        $config['charset'] = 'iso-8859-1';
        $config['wordwrap'] = TRUE;
        $config['mailtype'] = 'html';
        $this->email->initialize($config);
		ob_start();

		date_default_timezone_set('Asia/Calcutta');
	}

	public function index()
	{
		$result['msg']='';
		$this->load->view('login',$result);
	}

	public function user_is_logged_in()
	{
		$uid = $this->session->userdata('userid');
		$role = $this->session->userdata('role');
        if (empty($uid) or empty($role))
		{
			return false;
		}
		else
		{
			return true;
		}
	}	

	public function user_authentic()
	{
		if ($this->user_is_logged_in()==false)
		{			
			redirect(base_url("user/logout"));
		}
	}

	public function login()
	{
		$result['msg']='';
		$uid = $this->session->userdata('userid');
		if ($this->user_is_logged_in()==false)
		{
			$this->form_validation->set_rules('username', 'user name', 'trim|required|xss_clean');
			$this->form_validation->set_rules('passwd', 'password', 'trim|required');

			if ($this->form_validation->run() == FALSE)
			{
			   $this->load->view('login',$result);
			}
			else
			{
				$uname = $this->input->post('username');
				$pass=md5($this->input->post("passwd"));
				$result["result"]=$this->user_model->is_valid_user($uname,$pass);

				if($result['result'] !='')
				{
					$detail = array(
						'userid'=>$result['result']['id'],
						'useremail'=>$result['result']['emailid'],
						'username' => $result['result']['first_name'],
						'role' => $result['result']['role']
						);

					$this->session->set_userdata($detail);
					$this->user_home();
				}
				else
				{
					$result["msg"]="User name or password not valid.";
					$this->load->view("login",$result);
				}
			}
		}
		else
		{	
			$this->user_home();	
		}
	}

	public function logout()
	{
		//$this->session->sess_destroy();
        //setcookie(session_name(), "", time() - 3600);
		$result["msg"]="Logged out successfully.";	
		$this->load->view("login",$result);
	}	
	
	public function log_out()
	{
		$this->session->sess_destroy();
        setcookie(session_name(), "", time() - 3600);
		$result["msg"]="Logged out successfully.";	
		$this->load->view("login",$result);
	}	

	public function change_password()
	{
		$result['msg']='';
		$this->user_authentic();	

		if($_POST)
		{
			$this->form_validation->set_rules('old_password', 'old password', 'trim|required');
			$this->form_validation->set_rules('new_password', 'new password', 'trim|required|min_length[4]');
			$this->form_validation->set_rules('confirm_password', 'confirm password', 'trim|required|min_length[4]');		

			if ($this->form_validation->run())
			{
				$old_pass=md5($this->input->post("old_password"));
				$new_pass=md5($this->input->post("new_password"));				

				$temp = $this->user_model->update_tbl_data('users',array("id" => $this->session->userdata('userid'), "role" => $this->session->userdata('role'), "password" => $old_pass),array("password" => $new_pass));
					
				if($temp == 1){
					$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>Password successfully updated.</b></span></div>');
				}
				else{
					$this->session->set_flashdata('message', '<div align="left" style="color:red;" id="notify"><span><b>Incorrect old password.</b></span></div>');
				}

				redirect(base_url("user/change_password"));
			}		
		}		

		$this->template->title('User', 'Change Password');
		$this->template->set_layout('default')->build("change_password",$result);
	}

	public function user_home()
	{			
		$result['msg']='';
		$this->user_authentic();
		//$this->domain_model->update_domain_email_status();
		redirect(site_url("dashboard"));
	}
	
	public function forgot_password()
	{
		$result['msg']='';	

		if($_POST)
		{
			$this->form_validation->set_rules('email', 'email id', 'trim|required|min_length[5]|max_length[50]|valid_email');
			
			if ($this->form_validation->run())
			{
				$email=$this->input->post("email");
				
				$this->db->select("emailid, first_name");
				$this->db->limit(1, 0);
				$this->db->from("users");
				$this->db->where(array("is_active"=>"1", "emailid" => $email));
				$query = $this->db->order_by("id","desc")->get();
				
				if($query->num_rows()>0)
				{
					$new_pass = random_string('alnum', 6);
					$this->user_model->update_tbl_data('users',array("emailid" => $email),array("password" => md5($new_pass)));
					
					$login_info="Dear ".strtoupper($query->row()->first_name)."<br/><br/>
							Your new password is <br/><br/>
							 Password :".$new_pass."<br/><br/>
							 
							<br/><br/><br/><br/>Yours sincerely, <br/>
							The Innctech Team<br/>
							Innctech Solutions<br/>";
					
					$this->email->from('no-reply@innctech.in','Innctech Solutions');
					$this->email->to($email); 
					$this->email->subject('Password Recovery Mail');
					$this->email->message($login_info);	
					$this->email->send();
					
					$this->session->set_flashdata('message', '<div align="left" style="color:green;" id="notify"><span><b>Password successfully updated. Please check user mail box.</b></span></div>');
					redirect(site_url("user/login"));					
				}
				else
				{
					$result['msg']='Email id is not valid.';
				}				
			}		
		}		

		$this->load->view("forgot_pwd",$result);
	}
	
	public function unsubscribe(){
		
		if($this->uri->segment(3)!=''){
		$id = base64_decode($this->uri->segment(3));		
		
		$this->db->where("id",$id);
		
		$this->db->update("subscribers",array('is_active'=>2));	
		
		
		
		if( $this->db->affected_rows()>0){			
			$results['massage'] = '<h2 style="color:green;">You are unsubscribe successfully.</h2>';
		} else {
			$results['massage']  = '<h2 style="color:red;">You are not unsubscribe please try again latter.</h2>';			
		}
		
		}else {
		
			$results['massage']  = '<h2 style="color:red;">You are not unsubscribe please try again latter.</h2>';			
						
		}	
	$this->load->view('unsubscribe',$results);
	} 

} // End of the controller