<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Domain_model extends CI_Model{
	function __construct()
	{
		parent::__construct();
		$this->load->database();
	}

	public function get_total_domains()
	{
		$this->db->select("count(id) as total_domains");
		$this->db->from("domains");
		$this->db->where(array("is_active"=>"1", "owner" => $this->session->userdata('userid')));
		return $this->db->get()->row()->total_domains;
	}	

	public function get_domain_list()
	{
		$this->db->select("domains.id, domains.url, domains.domain_email, domains.email_status, domains.description, users.first_name, users.last_name, users.emailid");
		$this->db->from("domains");
		$this->db->join("users", "users.id = domains.owner");
		$this->db->where(array("domains.is_active"=>"1", "domains.owner" => $this->session->userdata('userid')));
		$this->db->order_by("domains.id", "desc");
		return $this->db->get()->result_array();
	}	

	public function insert_domains($data)
	{
		if($this->db->insert("domains",$data))
		{
			return true;
		}
		else
		{
			return false;
		}
	}	

	public function get_table($table, $fields, $condition_arr, $order_by = "id") 
	{
		$this->db->select($fields);	
        $this->db->from($table);
		if($condition_arr)
		{
			$this->db->where($condition_arr);
		}
		$this->db->order_by($order_by);
		return $this->db->get()->result_array();
	}
	
	public function get_table_row($table, $fields, $arr)
	{
		$this->db->select($fields);	

        $this->db->from($table);

		$this->db->where($arr);

		$query=$this->db->get();

		return $query->row_array();
	}

	public function insert_data($table, $data)
	{
		if($this->db->insert($table,$data))
		{
			return true;
		}
		else
		{
			return false;
		}
	}	
	
	public function update_tbl_data($table, $condition_arr, $data_arr)
	{
		$this->db->where($condition_arr);
        $this->db->update($table, $data_arr);
		return ($this->db->affected_rows() > 0) ? TRUE : FALSE; 
	}

	// Not in use
	/*public function update_domain_email_status()
	{		
		$this->load->library('simpleemailservice','', 'sms');
		$this->load->library('Simpleemailservicemessage','', 'smsm');
		
		
		$this->db->select("domains.id, domains.domain_email, domains.email_status");
		$this->db->from("domains");
		$this->db->where(array("domains.email_status"=>"0"));
		$this->db->order_by("domains.id", "asc");
		$result["domains"] = $this->db->get()->result_array();
		$email_list = $this->sms->listVerifiedEmailAddresses();
		foreach($result["domains"] as $row)
		{
			foreach($email_list["Addresses"] as $email)
			{
				if(strtoupper($email)==strtoupper($row["domain_email"]))
				{
					$this->db->where(array("domains.id"=>$row["id"]));
        			$this->db->update("domains", array("domains.email_status"=>1));
				}
			}
		}		
	}*/

	public function check_domain_email_is_verified($sent_mail_id)
	{				
		$this->db->select("domains.email_status, domains.domain_email");
		$this->db->from("sent_emails");
		$this->db->join("templates", "sent_emails.template_id = templates.id");		
		$this->db->join("domains", "domains.id = templates.domain_id");
		$this->db->where(array("sent_emails.id"=>$sent_mail_id, "domains.email_status" => 1, "sent_emails.owner" => $this->session->userdata('userid')));
					
		$result = $this->db->get()->row_array();		
	
		if(count($result)>0)
		{
			return $result["domain_email"];
		}
		else
		{
			return "";
		}
				
	}


		



		



}// End of the dealer model