<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Email_model extends CI_Model{

	function __construct()
	{
		parent::__construct();
		$this->load->database();
	}
	
	public function insert_mail_settings($data)
	{
		if($this->db->insert("sent_emails",$data))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public function get_publish_mail_list()
	{
		$this->db->select("sent_emails.id, sent_emails.subject, sent_emails.sent_date, templates.title, domains.url, (SELECT COUNT( publish_emails.id ) FROM publish_emails WHERE publish_emails.sent_mail_id = sent_emails.id AND publish_emails.sent_status =0) AS remaining_mail, (SELECT COUNT( publish_emails.id ) FROM publish_emails WHERE publish_emails.sent_mail_id = sent_emails.id AND publish_emails.sent_status =1) AS sent_mail, (SELECT COUNT( publish_emails.id ) FROM publish_emails WHERE publish_emails.sent_mail_id = sent_emails.id AND publish_emails.sent_status =2) AS in_process_mails");
		$this->db->from("sent_emails");
		$this->db->join("templates", "templates.id = sent_emails.template_id");
		$this->db->join("domains", "domains.id = templates.domain_id");
		$this->db->where(array("sent_emails.owner"=>$this->session->userdata('userid'), "sent_emails.status"=>0));
		$this->db->order_by("sent_emails.id", "asc");
		
		 $res = $this->db->get()->result_array();
		 //echo $this->db->last_query();die;
		 return $res;
	}

	public function update_publish_mail($id, $data)
	{
		$this->db->where("publish_emails.id", $id);
        $this->db->update("publish_emails", $data);
		return ($this->db->affected_rows() > 0) ? TRUE : FALSE; 
	}

	public function get_emails($from='',$to='',$domain_id='') // by default get curretn month sent emails.
	{
		/*$this->db->select('count(id) as sent_mails');
		$this->db->from("publish_emails");
		if(!empty($from) && !empty($to))
		$this->db->where(array("sent_status"=>1,'DATE(createdon) >='=>$from,'DATE(createdon) <='=>$to));	
		else
		$this->db->where(array("sent_status"=>1,'DATE(createdon)'=>date('Y-m-d')));		
		
		 $this->db->get()->row()->sent_mails;
		echo $this->db->last_query();die;*/

		/*==================================================*/
		if(!empty($from) && !empty($to))
		{
			$this->db->select("sent_emails.id, sent_emails.subject, sent_emails.sent_date, templates.title, domains.url,(SELECT COUNT( publish_emails.id ) FROM publish_emails WHERE publish_emails.sent_mail_id = sent_emails.id AND publish_emails.sent_status =1 AND DATE(createdon)>='".$from."' AND DATE(createdon)<='".$to."') AS sent_mail, domains.id as domain_id");
		}
		else
		{
			$this->db->select("sent_emails.id, sent_emails.subject, sent_emails.sent_date, templates.title, domains.url,(SELECT COUNT( publish_emails.id ) FROM publish_emails WHERE publish_emails.sent_mail_id = sent_emails.id AND publish_emails.sent_status =1 AND DATE(createdon)='".date('Y-m-d')."') AS sent_mail, domains.id as domain_id");
		}
		$this->db->from("sent_emails");
		$this->db->join("templates", "templates.id = sent_emails.template_id");
		$this->db->join("domains", "domains.id = templates.domain_id");
		$this->db->where(array("sent_emails.owner"=>$this->session->userdata('userid'), "sent_emails.status"=>0));
		if(!empty($domain_id))
		{
			$this->db->where(array('domain_id'=>$domain_id));
		}
		$this->db->order_by("sent_emails.id", "asc");
		$res = $this->db->get()->result_array();
		//echo $this->db->last_query();die;
		return $res;
	}
	public function delete_emails($from)
	{
		$this->db->from("publish_emails");
		$this->db->where(array("sent_status"=>1,'DATE(createdon) <'=>$from));
		$this->db->delete();
		return ($this->db->affected_rows() > 0) ? TRUE : FALSE; 
	}
	public function get_email_report($domain,$date_from,$date_to)
	{
		/*$this->db->select('p.id,p.subscriber_id,p.sent_status,p.createdon,s.domain_id');
		$this->db->from("publish_emails as p");
		$this->db->join("subscribers as s", "s.id = p.subscriber_id");
		$this->db->where(array('s.domain_id'=>$domain));
		$this->db->where(array('DATE(createdon) >='=>$date_from,'DATE(createdon) <='=>$date_to));
		return $this->db->get()->result_array();*/
		/*===============================================*/

		$query = $this->db->query("SELECT `publish_emails`.`sent_mail_id`, DATE(`publish_emails`.`createdon`) as pubdate, SUM(CASE WHEN `publish_emails`.`sent_status` = 0 THEN 1 ELSE 0 END) AS 'Pending', SUM(CASE WHEN `publish_emails`.`sent_status` = 1 THEN 1 ELSE 0 END) AS 'Sent', SUM(CASE WHEN `publish_emails`.`sent_status` = 2 THEN 1 ELSE 0 END) AS 'Inprocess' FROM `publish_emails` JOIN `sent_emails` ON `sent_emails`.`id` = `publish_emails`.`sent_mail_id` JOIN `templates` ON `templates`.`id` = `sent_emails`.`template_id` JOIN `domains` ON `domains`.`id` = `templates`.`domain_id` WHERE `sent_emails`.`owner` = '".$this->session->userdata('userid')."' AND `sent_emails`.`status` = 0 AND `domains`.`id` = '$domain' AND DATE(`publish_emails`.`createdon`) >= '$date_from' AND DATE(`publish_emails`.`createdon`) <= '$date_to' GROUP BY pubdate ORDER BY `publish_emails`.`createdon` DESC");

		$row = $query->result_array();
		return $row;
		//echo $this->db->last_query();die;
		
	}	




}// End of the dealer model