<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	class Subscriber_model extends CI_Model{
		
	function __construct()
	{
		parent::__construct();
		$this->load->database();
	}

	public function get_total_subscribers()
	{
		$this->db->select("count(subscribers.id) as total_subscribers");
		$this->db->from("subscribers");
		$this->db->join("domains", "domains.id = subscribers.domain_id");
		$this->db->where(array("subscribers.is_active"=>"1", "domains.owner" => $this->session->userdata('userid')));
		return $this->db->get()->row()->total_subscribers;
	}

	public function get_subscriber_list($pp=25, $range=0)
	{
		$this->db->select("subscribers.id, subscribers.email, subscribers.name, subscribers.is_active, domains.url");
		$this->db->from("subscribers");
		$this->db->join("domains", "domains.id = subscribers.domain_id");

		$this->db->where(array("domains.owner" => $this->session->userdata('userid')));

		//$this->db->order_by("domains.url", "asc");

		$this->db->order_by("subscribers.id", "desc");

		$this->db->limit($pp, $range);

		return $this->db->get()->result_array();
	}

	public function search_subscriber($arr, $pp=10000, $range=0)
	{					
		$keyword = $arr['keyword'];			
		
		$this->db->select("subscribers.id, subscribers.email, subscribers.name, subscribers.is_active, domains.url");
		$this->db->from("subscribers");	
		$this->db->join("domains", "domains.id = subscribers.domain_id");	
		$this->db->where(array("domains.owner" => $this->session->userdata('userid')));
		$this->db->like('subscribers.email', $arr['keyword']); 	
		$this->db->order_by("domains.url", "asc");	
		$this->db->order_by("subscribers.id", "desc");	
		$this->db->limit($pp, $range);	
		return $this->db->get()->result_array();
	}

	public function search_subscriber_all($arr)
	{					
		$keyword = $arr['keyword'];			
		
		$this->db->select("count(subscribers.id) as total_subscribers");
		$this->db->from("subscribers");	
		$this->db->join("domains", "domains.id = subscribers.domain_id");	
		$this->db->where(array("domains.owner" => $this->session->userdata('userid')));
		$this->db->like('subscribers.email', $arr['keyword']); 	
		$this->db->order_by("domains.url", "asc");	
		$this->db->order_by("subscribers.id", "desc");
		return $this->db->get()->row()->total_subscribers;
	}

	public function get_required_subscriber($subscriberid)

	{

		$this->db->select("subscribers.id, subscribers.domain_id, subscribers.email, subscribers.name, subscribers.is_active");

		$this->db->from("subscribers");

		$this->db->join("domains", "domains.id = subscribers.domain_id");

		$this->db->where(array("domains.owner" => $this->session->userdata('userid'), "subscribers.id" => $subscriberid));

		return $this->db->get()->row_array();

	}

	

	public function insert_subscribers($data)

	{

		if($this->db->insert("subscribers",$data))

		{

			return true;

		}

		else

		{

			return false;

		}

	}	

	



	public function update_subscribers($subscriberid, $data)

	{

		$this->db->where("subscribers.id", $subscriberid);

        $this->db->update("subscribers", $data);

		return ($this->db->affected_rows() > 0) ? TRUE : FALSE; 

	}

	public function get_subscribers_count($domain_id)
	{
		$this->db->select("count(subscribers.id) as total_subscribers");
		$this->db->from("subscribers");
		$this->db->join("domains", "domains.id = subscribers.domain_id");
		$this->db->where(array("subscribers.is_active"=>"1",'domain_id'=>$domain_id, "domains.owner" => $this->session->userdata('userid')));
		return $this->db->get()->row()->total_subscribers;
	}






		



		



}// End of the dealer model